#include <stdio.h>

inline unsigned long int GetTick()
{
  unsigned long int x;
  __asm__ volatile ("RDTSC" : "=A" (x));
  return x;
}

#define CACHESIZE 1000000
int trash[CACHESIZE];
void TrashCache()
{ int i;  for (i=0; i<CACHESIZE; i++) trash[i]++; }


void TabInc(const unsigned int n, int tab[n][n])
{
  register int i,j;
  for (j=0; j<n; j++)
    for (i=0; i<n; i++)
      tab[i][j]++;
}

int main(void)
{
  unsigned long int tm, t1, t2, t3;
  int n, *tab, i;
  
  for (n=4; n <= 1024; n=n<<1)
    {
      tab = (int *) malloc(sizeof(int[n][n]));
      printf("n = %4d, Cycles :", n);
      for (i=0; i<5; i++)
	{
	  tm = GetTick(); TabInc(n, tab); t1  = GetTick()-tm;
	  printf(" %10Ld", t1);
	};
      printf("\nn = %4d, Cache  :", n);
      for (i=0; i<5; i++)
	{
	  //	  TrashCache();
	  tm = GetTick(); TabInc(n, tab); t1  = GetTick()-tm;
	  printf(" %10Ld", t1);
	};
      printf("\n");
    }
  return(0);
}

