#include <sched.h>
#include <stdio.h>

inline unsigned long long int GetTick()
{
  unsigned long long int x;
  __asm__ volatile ("RDTSC" : "=A" (x));
  return x;
}

#define CACHESIZE 2000000
int trash[CACHESIZE];
void TrashCache()
{ int i;
for (i=0; i<CACHESIZE; i++) trash[i]++;
for (i=0; i<CACHESIZE; i++) trash[i]++;
for (i=0; i<CACHESIZE; i++) trash[i]++; }


void TabInc(const unsigned int n, int tab[n][n])
{
  register int i,j;
  for (j=0; j<n; j++)
    for (i=0; i<n; i++)
      tab[i][j]++;
}

int main(void)
{
  long long int tm, t1, t2, t3;
  int n, *tab, i;
  struct sched_param schp;
  
  printf("Changement de priorit :\n");
  schp.sched_priority = sched_get_priority_max(SCHED_FIFO);
  printf("Priorit maximale = %d. ", schp.sched_priority);
  if (!sched_setscheduler(0, SCHED_FIFO, &schp)) printf("Ok !\n");	
  else printf("Impossible de changer la priorit !\n");	

  for (n=4; n <= 1024; n=n<<1)
    {
      tab = (int *) malloc(sizeof(int[n][n]));
      printf("n = %4d, cycles :", n);
      for (i=0; i<5; i++)
	{
	  tm = GetTick(); TabInc(n, tab); t1  = GetTick()-tm;
	  printf(" %10Ld", t1);
	};
      printf("\n           Cache :", n);
      for (i=0; i<5; i++)
	{
	  TrashCache();
	  tm = GetTick(); TabInc(n, tab); t1  = GetTick()-tm;
	  printf(" %10Ld", t1);
	};
      printf("\n");
    }
  return(0);
}

