#include <sched.h>
#include <stdio.h>

inline unsigned long long int GetTick()
{
  unsigned long long int x;
  __asm__ volatile ("RDTSC" : "=A" (x));
  return x;
}	

#define CACHESIZE 1000000
int trash[CACHESIZE];
void TrashCache()
{ int i; for (i=0; i<CACHESIZE; i++) trash[i]++; }


void IncTab1(const unsigned int n, int tab[n][n])
{
  register int i,j;
  for (j=0; j<n; j++)
    for (i=0; i<n; i++)
      tab[i][j]++;
}


void IncTab2(const unsigned int n, int tab[n][n])
{
  register int i,j;
  for (i=0; i<n; i++)
    for (j=0; j<n; j++)
      tab[i][j]++;
}


void IncTab3(const unsigned int n, int tab[n][n])
{
  register int i,j,jj;
  int borne;
  int *pt;
  for (i=0; i<n; i++)
    {
	for (j=0; j<n; j=borne)
	{
	    borne = j+64;
	    if (borne > n) borne = n;
	    pt = &(tab[i][j+32]);
	    __asm__ __volatile__("prefetchnta   0(%0)" : : "D" (pt));
	    __asm__ __volatile__("prefetchnta  64(%0)" : : "D" (pt));
	    __asm__ __volatile__("prefetchnta 128(%0)" : : "D" (pt));
	    __asm__ __volatile__("prefetchnta 192(%0)" : : "D" (pt));
	    for (jj=j; jj<borne; jj++) tab[i][jj]++;
	}
    }
}

int main(void)
{
  long long int tm, t1, t2, t3;
  int n, *tab;
  struct sched_param schp;
  
  printf("Changement de priorit :\n");
  schp.sched_priority = sched_get_priority_max(SCHED_FIFO);
  printf("Priorit maximale = %d. ", schp.sched_priority);
  if (!sched_setscheduler(0, SCHED_FIFO, &schp)) printf("Ok !\n");	
  else printf("Impossible de changer la priorit !\n");	

  for (n=4; n <= 4096; n=n<<1)
    {
      tab = (int *) malloc(sizeof(int[n][n]));

      TrashCache();
      tm = GetTick(); IncTab1(n, tab); t1 = GetTick()-tm;

      TrashCache();
      tm = GetTick(); IncTab2(n,tab);  t2 = GetTick()-tm;

      TrashCache();
      tm = GetTick(); IncTab3(n,tab);  t3 = GetTick()-tm;

      free(tab);

      printf("n = %4d, temps (cycles) : "
	     "%10Ld %9Ld (%5.2f) %9Ld (%5.2f, %5.2f) \n",
	     n, t1, t2, 1.*t1/t2, t3, 1.*t1/t3, 1.*t2/t3);
    }
  return(0);
}

